Index: XIOS/trunk/src/client.cpp
===================================================================
--- XIOS/trunk/src/client.cpp	(revision 492)
+++ XIOS/trunk/src/client.cpp	(revision 493)
@@ -92,4 +92,10 @@
             int clientLeader=leaders[hashClient] ;
             serverLeader=leaders[hashServer] ;
+
+            int intraCommSize, intraCommRank ;
+            MPI_Comm_size(intraComm,&intraCommSize) ;
+            MPI_Comm_rank(intraComm,&intraCommRank) ;
+            info(50)<<"intercommCreate::client "<<rank<<" intraCommSize : "<<intraCommSize
+                 <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< serverLeader<<endl ;
             MPI_Intercomm_create(intraComm,0,CXios::globalComm,serverLeader,0,&interComm) ;
           }
Index: XIOS/trunk/src/node/domain.cpp
===================================================================
--- XIOS/trunk/src/node/domain.cpp	(revision 492)
+++ XIOS/trunk/src/node/domain.cpp	(revision 493)
@@ -171,5 +171,4 @@
           ibegin.getValue() < 1 || iend.getValue() > ni_glo.getValue())
           {
-                  cout<<ni_glo<<"  "<<ni<<"  "<<ibegin<<"  "<<iend<<endl;
 
          ERROR("CDomain::checkAttributes(void)",
Index: XIOS/trunk/src/node/field.cpp
===================================================================
--- XIOS/trunk/src/node/field.cpp	(revision 492)
+++ XIOS/trunk/src/node/field.cpp	(revision 493)
@@ -792,5 +792,4 @@
            instantField->freq_op=freq_op ;
            averageField-> processEnabledField() ;
-           cout<<" outputfreq of averageField "<<  freq_op <<"  "<<instantField->freq_op<<"  "<< averageField->freq_write << endl ;
            instantField->SuperClassAttribute::setAttributes(averageField, true);
            instantField->field_ref.reset() ;
Index: XIOS/trunk/src/parse_expr/yacc_parser.cpp
===================================================================
--- XIOS/trunk/src/parse_expr/yacc_parser.cpp	(revision 492)
+++ XIOS/trunk/src/parse_expr/yacc_parser.cpp	(revision 493)
@@ -74,5 +74,9 @@
 #include <string>
 #include <iostream>
+#include "exception.hpp"
+
 using namespace std ;
+using namespace xios ;
+
 extern "C"
 {
@@ -101,5 +105,5 @@
 
 /* Line 189 of yacc.c  */
-#line 104 "yacc_parser.cpp"
+#line 108 "yacc_parser.cpp"
 
 /* Enabling traces.  */
@@ -151,5 +155,5 @@
 
 /* Line 214 of yacc.c  */
-#line 32 "yacc_parser.yacc"
+#line 36 "yacc_parser.yacc"
 
     std::string* str ;                /* symbol table index */
@@ -159,5 +163,5 @@
 
 /* Line 214 of yacc.c  */
-#line 162 "yacc_parser.cpp"
+#line 166 "yacc_parser.cpp"
 } YYSTYPE;
 # define YYSTYPE_IS_TRIVIAL 1
@@ -171,5 +175,5 @@
 
 /* Line 264 of yacc.c  */
-#line 174 "yacc_parser.cpp"
+#line 178 "yacc_parser.cpp"
 
 #ifdef short
@@ -468,8 +472,8 @@
 static const yytype_uint8 yyrline[] =
 {
-       0,    54,    54,    55,    59,    60,    61,    62,    63,    64,
-      65,    66,    67,    68,    72,    73,    74,    75,    76,    77,
-      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
-      88,    89,    90
+       0,    58,    58,    59,    63,    64,    65,    66,    67,    68,
+      69,    70,    71,    72,    76,    77,    78,    79,    80,    81,
+      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
+      92,    93,    94
 };
 #endif
@@ -1422,6 +1426,6 @@
 
 /* Line 1455 of yacc.c  */
-#line 54 "yacc_parser.yacc"
-    { cout<<"The end: \n"; ;}
+#line 58 "yacc_parser.yacc"
+    {  ;}
     break;
 
@@ -1429,6 +1433,6 @@
 
 /* Line 1455 of yacc.c  */
-#line 55 "yacc_parser.yacc"
-    { cout<<"Parsed  END..."<<endl ; parsed=(yyvsp[(1) - (2)].node) ;;}
+#line 59 "yacc_parser.yacc"
+    {  parsed=(yyvsp[(1) - (2)].node) ;;}
     break;
 
@@ -1436,5 +1440,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 59 "yacc_parser.yacc"
+#line 63 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::scalarDouble,(yyvsp[(1) - (1)].str)); delete (yyvsp[(1) - (1)].str) ;}
     break;
@@ -1443,5 +1447,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 60 "yacc_parser.yacc"
+#line 64 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::scalarVariable,(yyvsp[(1) - (1)].str)) ; delete (yyvsp[(1) - (1)].str);}
     break;
@@ -1450,5 +1454,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 61 "yacc_parser.yacc"
+#line 65 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opScalarScalar,"add") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1457,5 +1461,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 62 "yacc_parser.yacc"
+#line 66 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opScalarScalar,"minus") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1464,5 +1468,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 63 "yacc_parser.yacc"
+#line 67 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opScalarScalar,"mult") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1471,5 +1475,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 64 "yacc_parser.yacc"
+#line 68 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opScalarScalar,"div") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1478,5 +1482,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 65 "yacc_parser.yacc"
+#line 69 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opScalar,"neg") ;  (yyval.node)->addChild((yyvsp[(2) - (2)].node)); ;}
     break;
@@ -1485,5 +1489,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 66 "yacc_parser.yacc"
+#line 70 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opScalarScalar,"pow") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1492,5 +1496,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 67 "yacc_parser.yacc"
+#line 71 "yacc_parser.yacc"
     { (yyval.node)=(yyvsp[(2) - (3)].node) ; ;}
     break;
@@ -1499,5 +1503,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 68 "yacc_parser.yacc"
+#line 72 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opScalar,(yyvsp[(1) - (4)].str)) ; (yyval.node)->addChild((yyvsp[(3) - (4)].node)) ; delete (yyvsp[(1) - (4)].str) ;}
     break;
@@ -1506,5 +1510,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 72 "yacc_parser.yacc"
+#line 76 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::fieldInstant,(yyvsp[(1) - (1)].str)); delete (yyvsp[(1) - (1)].str);}
     break;
@@ -1513,5 +1517,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 73 "yacc_parser.yacc"
+#line 77 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::fieldAverage,(yyvsp[(1) - (1)].str)); delete (yyvsp[(1) - (1)].str);}
     break;
@@ -1520,5 +1524,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 74 "yacc_parser.yacc"
+#line 78 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opFieldField,"add") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1527,5 +1531,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 75 "yacc_parser.yacc"
+#line 79 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opFieldField,"minus") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1534,5 +1538,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 76 "yacc_parser.yacc"
+#line 80 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opFieldField,"mult") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1541,5 +1545,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 77 "yacc_parser.yacc"
+#line 81 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opFieldField,"div") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1548,5 +1552,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 78 "yacc_parser.yacc"
+#line 82 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opField,"neg") ; (yyval.node)->addChild((yyvsp[(2) - (2)].node));;}
     break;
@@ -1555,5 +1559,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 79 "yacc_parser.yacc"
+#line 83 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opFieldField,"pow") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1562,5 +1566,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 80 "yacc_parser.yacc"
+#line 84 "yacc_parser.yacc"
     { (yyval.node)=(yyvsp[(2) - (3)].node) ;;}
     break;
@@ -1569,5 +1573,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 81 "yacc_parser.yacc"
+#line 85 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opFieldScalar,"add") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1576,5 +1580,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 82 "yacc_parser.yacc"
+#line 86 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opScalarField,"add") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1583,5 +1587,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 83 "yacc_parser.yacc"
+#line 87 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opFieldScalar,"minus") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1590,5 +1594,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 84 "yacc_parser.yacc"
+#line 88 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opScalarField,"minus") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1597,5 +1601,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 85 "yacc_parser.yacc"
+#line 89 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opFieldScalar,"mult") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1604,5 +1608,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 86 "yacc_parser.yacc"
+#line 90 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opScalarField,"mult") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1611,5 +1615,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 87 "yacc_parser.yacc"
+#line 91 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opFieldScalar,"div") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1618,5 +1622,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 88 "yacc_parser.yacc"
+#line 92 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opScalarField,"div") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1625,5 +1629,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 89 "yacc_parser.yacc"
+#line 93 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opFieldScalar,"pow") ; (yyval.node)->addChild((yyvsp[(1) - (3)].node)) ; (yyval.node)->addChild((yyvsp[(3) - (3)].node)); ;}
     break;
@@ -1632,5 +1636,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 90 "yacc_parser.yacc"
+#line 94 "yacc_parser.yacc"
     { (yyval.node)=new CSimpleNodeExpr(CSimpleNodeExpr::opField,(yyvsp[(1) - (4)].str)) ;  (yyval.node)->addChild((yyvsp[(3) - (4)].node)) ; delete (yyvsp[(1) - (4)].str);}
     break;
@@ -1639,5 +1643,5 @@
 
 /* Line 1455 of yacc.c  */
-#line 1640 "yacc_parser.cpp"
+#line 1644 "yacc_parser.cpp"
       default: break;
     }
@@ -1851,5 +1855,5 @@
 
 /* Line 1675 of yacc.c  */
-#line 92 "yacc_parser.yacc"
+#line 96 "yacc_parser.yacc"
 
 
@@ -1858,5 +1862,5 @@
   int yyerror(const char *s) 
   {
-    cout<<"Parsing error :"<<s<<endl ; 
+    ERROR("int yyerror(const char *s)", <<"Parsing error :"<<s<<endl) ; 
   }
 }
@@ -1866,5 +1870,4 @@
   CSimpleNodeExpr* parseExpr(const string& strExpr)
   {
-    cout<<strExpr<<endl ;
     globalInputText=strExpr ;
     globalReadOffset=0 ;
Index: XIOS/trunk/src/parse_expr/yacc_parser.hpp
===================================================================
--- XIOS/trunk/src/parse_expr/yacc_parser.hpp	(revision 492)
+++ XIOS/trunk/src/parse_expr/yacc_parser.hpp	(revision 493)
@@ -63,5 +63,5 @@
 
 /* Line 1676 of yacc.c  */
-#line 32 "yacc_parser.yacc"
+#line 36 "yacc_parser.yacc"
 
     std::string* str ;                /* symbol table index */
Index: XIOS/trunk/src/parse_expr/yacc_parser.yacc
===================================================================
--- XIOS/trunk/src/parse_expr/yacc_parser.yacc	(revision 492)
+++ XIOS/trunk/src/parse_expr/yacc_parser.yacc	(revision 493)
@@ -3,5 +3,9 @@
 #include <string>
 #include <iostream>
+#include "exception.hpp"
+
 using namespace std ;
+using namespace xios ;
+
 extern "C"
 {
@@ -52,6 +56,6 @@
 
 Line:
-     END                           { cout<<"The end: \n"; }
-   | Field_expr END { cout<<"Parsed  END..."<<endl ; parsed=$1 ;}
+     END                           {  }
+   | Field_expr END {  parsed=$1 ;}
    ;
 
@@ -96,5 +100,5 @@
   int yyerror(const char *s) 
   {
-    cout<<"Parsing error :"<<s<<endl ; 
+    ERROR("int yyerror(const char *s)", <<"Parsing error :"<<s<<endl) ; 
   }
 }
@@ -104,5 +108,4 @@
   CSimpleNodeExpr* parseExpr(const string& strExpr)
   {
-    cout<<strExpr<<endl ;
     globalInputText=strExpr ;
     globalReadOffset=0 ;
Index: XIOS/trunk/src/server.cpp
===================================================================
--- XIOS/trunk/src/server.cpp	(revision 492)
+++ XIOS/trunk/src/server.cpp	(revision 493)
@@ -91,6 +91,6 @@
              MPI_Comm_size(intraComm,&intraCommSize) ;
              MPI_Comm_rank(intraComm,&intraCommRank) ;
-             cout<<"intercommCreate::server "<<rank<<" intraCommSize : "<<intraCommSize
-                 <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< clientLeader<<endl ;
+             info(50)<<"intercommCreate::server "<<rank<<" intraCommSize : "<<intraCommSize
+                     <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< clientLeader<<endl ;
 
              MPI_Intercomm_create(intraComm,0,CXios::globalComm,clientLeader,0,&newComm) ;